<template>
  <div class="flex"
    v-if="variant === 'modal'"
  >
    <slot name="modal">
      <svn-modal-skeleton
        ref="modal"
        fullscreen
        transition="slide-x-transition"
        header-custom-class="!border-0 !p-0 !h-6"
        modal-custom-class="gap-6 p-4 min-w-full"
        modal-title=""
        modal
      >
        <template #activator>
          <slot name="modal-activator">
            <svn-icon-button
              icon="mdi:menu"
              size="lg"
              variant="neutral"
            />
          </slot>
        </template>
        
        <template #content-body>
          <slot name="modal-content-body">
            <div class="flex flex-col gap-4 h-full">
              <v-list class="flex flex-col !p-2 gap-4 w-fit">
                <v-list-item
                  v-for="(item, idx) in items"
                  :key="idx"
                  class="text-sm !p-0 !min-h-0 font-medium"
                  @click="redirect(item.to)"
                >
                  {{item.title}}
                </v-list-item>
              </v-list>

              <div class="grow"/>

              <div class="flex p-2 justify-center items-center gap-2">
                <svn-button prepend-icon="mdi:logout" prepend-class="text-negative-red h-4 w-4" variant="neutral" text="Log out" />
              </div>
            </div>
          </slot>
        </template>
      </svn-modal-skeleton>
    </slot>
  </div>

  <v-menu
    v-if="variant === 'select'"
    transition="scale-transition"
  >
    <template #activator="{ props }">
      <div
        class="hidden sm:flex gap-2 items-center !min-w-fit cursor-pointer py-[11px] px-[10px]"
        v-bind="props"
      >
        <p class="text-sm font-bold">
          Current page name
        </p>

        <Icon
          icon="mdi:arrow-down-drop"
          class="h-6 w-6"
        />
      </div>
    </template>

    <v-list class="mt-6">
      <v-list-item
        v-for="(item, i) in items"
        :key="i"
        :value="item"
      >
        <template #prepend>
          <img
            :src="item.icon"
            alt=""
            class="mr-4 h-4"
          >
        </template>

        <v-list-item-title
          v-text="item.title"
          @click="redirect(item.to)"
        />
      </v-list-item>
    </v-list>
  </v-menu>

  <div
    v-if="variant === 'navbar'"
    class="gap-4 items-center flex"
  >
    <router-link
      v-for="item in items"
      :value="item"
      class="py-[11px] px-2.5 text-xs rounded select-none hover:bg-light-grey"
      :key="item?.to"
      :to="item.to"
    >
      <svn-text sm medium>
        {{ item.title }}
      </svn-text>
    </router-link>
  </div>
</template>

<script setup>
import { ref } from "vue";
import { useRoute } from "vue-router";
import { Icon } from "@iconify/vue";
import SvnButton from "../button/SvnButton.vue";
import SvnIconButton from "@/components/button/SvnIconButton.vue";
import SvnModalSkeleton from "@/components/skeleton/SvnModalSkeleton.vue";

const props = defineProps({
  variant: { type: String, default : '' },
  items: { type: Array, default: () => [] },
})

const modal = ref(null)

const emit = defineEmits(['navigate'])

const redirect = (to) => {
  if(to) {
    if (modal.value) modal.value.dialog = false
    emit('navigate', to)
  }
}

defineExpose({
  modal
})
</script>

<style scoped>

</style>